std::array::rbegin,std::array::crbegin(3)

NAME
std::array::rbegin,std::array::crbegin - std::array::rbegin,std::array::crbegin

Synopsis
   reverse_iterator rbegin() noexcept; (1) (since C++11)
                        (constexpr since C++17)
   const_reverse_iterator rbegin() const noexcept; (2) (since C++11)
                        (constexpr since C++17)
   const_reverse_iterator crbegin() const noexcept; (3) (since C++11)
                        (constexpr since C++17)
   Returns a reverse iterator to the first element of the reversed array. It
   corresponds to the last element of the non-reversed array. If the array is empty,
   the returned iterator is equal to rend().
   range-rbegin-rend.svg

Parameters
   (none)

Return value
   Reverse iterator to the first element.

Complexity
   Constant.

Notes
   The underlying iterator of the returned reverse iterator is the end iterator. Hence
   the returned iterator is invalidated if and when the end iterator is invalidated.

Example
// Run this code
 #include <algorithm>
 #include <array>
 #include <iostream>
 #include <string>
 #include <string_view>
 int main()
 {
     constexpr std::array<std::string_view, 8> data = {"▁","▂","▃","▄","▅","▆","▇","█"};
     std::array<std::string, std::size(data)> arr;
     std::copy(data.cbegin(), data.cend(), arr.begin());
     // ^ ^ ^
     auto print = [](const std::string_view s) { std::cout << s << ' '; };
     print("Print 'arr' in direct order using [cbegin, cend):\t");
     std::for_each(arr.cbegin(), arr.cend(), print);
     // ^ ^
     print("\n\nPrint 'arr' in reverse order using [crbegin, crend):\t");
     std::for_each(arr.crbegin(), arr.crend(), print);
     // ^^ ^^
     print("\n");
 }

Output:
 Print 'arr' in direct order using [cbegin, cend): ▁ ▂ ▃ ▄ ▅ ▆ ▇ █
 Print 'arr' in reverse order using [crbegin, crend): █ ▇ ▆ ▅ ▄ ▃ ▂ ▁

See also
   rend returns a reverse iterator to the end
   crend (public member function)
   rbegin returns a reverse iterator to the beginning of a container or array
   crbegin (function template)
   (C++14)